<?php
// リアクションの設定
const REACTION_CONFIG = [
    'reactions' => [
//'CSVに記録される名前' => '表示される絵文字'
        'like' => '👍',
        'bad' => '👎',
        'heart' => '♥',
        'laugh' => 'laugh.png', // .png,.gif,.jpg,.svgが使えます
        'sad' => '😢',
        'love' => '😍',
        'cold' => '🥶',
        '100ten' => '💯',
        'thanks' => '🙏',
    ],
    // リアクション制限の設定
    'limits' => [
        'daily' => true,     // true: 1日で制限リセット, false: 無期限
        'perIP' => 1,       // IP毎の制限回数daily = falseの場合のみ使用）
        'dailyLimit' => 100   // 1日あたりの制限回数（daily = trueの場合のみ使用）
    ],
    // リアクションの表示初期展開数
    'display' => [
        'initialButtons' => 5  // 初期表示するボタンの数
    ],
    // 拒否するIPアドレスのリスト
    'blockedIPs' => [ 
        // '192.168.1.100',  // コメントを外して IP を追加すると制限が有効になります
    ]
];
// JavaScriptとして出力する場合
if (isset($_GET['format']) && $_GET['format'] === 'js') {
    header('Content-Type: application/javascript');
    // セキュリティのため、クライアントには拒否IPリストを送信しない
    $clientConfig = REACTION_CONFIG;
    unset($clientConfig['blockedIPs']);
    echo 'const REACTION_CONFIG = ' . json_encode($clientConfig) . ';';
    exit;
}

// IPアドレスがブロックされているかチェックする関数
function isIPBlocked($ip) {
    // ブロックリストが空の場合は制限なし
    if (empty(REACTION_CONFIG['blockedIPs'])) {
        return false;
    }
    
    return in_array($ip, REACTION_CONFIG['blockedIPs']);
}

// IPアドレスが範囲内にあるかチェックする関数
function isIPInRange($ip, $range) {
    list($range, $netmask) = explode('/', $range, 2);
    $range_decimal = ip2long($range);
    $ip_decimal = ip2long($ip);
    $wildcard_decimal = pow(2, (32 - $netmask)) - 1;
    $netmask_decimal = ~ $wildcard_decimal;
    return (($ip_decimal & $netmask_decimal) == ($range_decimal & $netmask_decimal));
} 